/***********************************************************************************************************************
 *
 * blueBill Core - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it
 * SCM: https://java.net/hg/bluebill~core-src
 *
 **********************************************************************************************************************/
package it.tidalwave.observation;

import javax.annotation.Nonnull;
import javax.annotation.concurrent.Immutable;
import java.io.Serializable;
import it.tidalwave.util.StringValue;

/***********************************************************************************************************************
 *
 * A text note that can be bound to an {@link ObservationItem}.
 * 
 * @stereotype Datum
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@Immutable
public class TextNote implements Serializable, StringValue
  {
    private final static long serialVersionUID = 12121656347568673L;
    
    public static final Class<TextNote> TextNote = TextNote.class;
    
    private final String string;

    @Nonnull
    public static TextNote note (final @Nonnull String string)
      {
        return new TextNote(string);
      }

    public TextNote (final @Nonnull String string)
      {
        this.string = string;
      }

    @Nonnull
    public String stringValue()
      {
        return string;
      }

    @Override @Nonnull
    public String toString()
      {
        return String.format("TextNote[%s]", string);
      }
  }
